clc;clear
%conver case from bin2dec
DataOrg_bin = textread("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/case/TC_SingleWaveCombine_bin.txt",'%s');
DataOrg_dec = bin2dec(DataOrg_bin);
DataOrg_hex = string(dec2hex(DataOrg_dec,8));

DataRead_hex = upper(string(textread("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/FIL/sim/ConfigData.dat",'%s')));
%%
%read data 
clc;clear;close all
dout0 = importdata("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/FIL/sim/dout0.dat")-32768;  
dout1 = importdata("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/FIL/sim/dout1.dat")-32768;
dout2 = importdata("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/FIL/sim/dout2.dat")-32768;
dout3 = importdata("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/FIL/sim/dout3.dat")-32768;
en    = importdata("/home/thfu/work/Z-noSFQ/EZQ-Z-M-v1.0/FIL/sim/en.dat"   )      ;

N_all = length(dout0);
cs_wave_all(1:4:4*N_all) = dout0;
cs_wave_all(2:4:4*N_all) = dout1;
cs_wave_all(3:4:4*N_all) = dout2;
cs_wave_all(4:4:4*N_all) = dout3;

start_indices = find(en(1:end-1) == 0 & en(2:end) == 1) + 1;  %point from 0 to 1
end_indices   = find(en(1:end-1) == 1 & en(2:end) == 0);

figure()
for i = 1:length(start_indices)
    N = end_indices(i) - start_indices(i) + 1;
    cs_wave{i}(1:4:4*N) = dout0(start_indices(i):end_indices(i));
    cs_wave{i}(2:4:4*N) = dout1(start_indices(i):end_indices(i));
    cs_wave{i}(3:4:4*N) = dout2(start_indices(i):end_indices(i));
    cs_wave{i}(4:4:4*N) = dout3(start_indices(i):end_indices(i));
    subplot(20,5,i);
    plot(cs_wave{i});
end

% signalAnalyzer(cs_wave_all,'SampleRate',1);
%%
N    = 31;                       % length of data
fs   = 1;                      
fe   = 0.3;                       % center frequency
D    = 1;                        
nfft = 32;
[y,freq]=exzfft_ma(cs_wave_split{1},fe,fs,nfft,D);  

figure(1)
plot(freq,abs(y))
